using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Drawing;
using System.Drawing.Imaging;
using System.ComponentModel;
using System.Drawing.Drawing2D;
using System.IO;

public partial class SignImage : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string[] fonts = Directory.GetFiles(Server.MapPath("App_Data\\fonts\\"));
        
        string txt = Request.QueryString["txt1"].ToString();
        Bitmap b = new Bitmap(100, 100);
        System.Drawing.Text.PrivateFontCollection privateFonts = new System.Drawing.Text.PrivateFontCollection();
        privateFonts.AddFontFile(fonts[RandomNumber(0,fonts.Length-1)]); // Set the font here
        Font f = new Font(privateFonts.Families[0], 50,FontStyle.Bold,GraphicsUnit.Pixel);
        Graphics graphics = Graphics.FromImage(b);
        int width = (int)graphics.MeasureString(txt, f).Width;
        int height = (int)graphics.MeasureString(txt, f).Height+10;
        b = new Bitmap(b, new Size(width, height));
        graphics = Graphics.FromImage(b);
        graphics.Clear(Color.White);
        graphics.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighQuality;
        graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
        graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
        graphics.DrawString(txt, f, new SolidBrush(Color.Black), 0, 0);
        graphics.Flush();
        b = RotateImage(b, 355);
        b.Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);

    }

    public static System.Drawing.Bitmap RotateImage(System.Drawing.Image img, float rotationAngle)
    {
        Bitmap bmp = new Bitmap(img.Width+40, img.Height+40);
        Graphics gfx = Graphics.FromImage(bmp);
        gfx.Clear(Color.White);
        Matrix X = new Matrix();
        X.Rotate(rotationAngle);
        gfx.Transform = X;
        gfx.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighQuality;
        gfx.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
        gfx.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
        gfx.DrawImage(img, new Point(0+2, 0+3));
        gfx.Dispose();
        return bmp;
    }

    private int RandomNumber(int min, int max)
    {
        Random random = new Random();
        return random.Next(min, max);
    }
}
